<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <title>Task62</title>
</head>

<body>
  <div class="container">
    <h2>Responsive Form</h2>
    <p>sample forms 02: multi colums</p>

    <form id="inputform01" class="jumbotron">
      <div class="row form-group">
        <div class="col-sm-2 px-1">
          <label for="fname">First Name</label>
        </div>
        <div class="col-sm-10 px-1">
          <input type="text" id="fname" name="firstname" placeholder="Your name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-2 px-1">
          <label for="lname">Last Name</label>
        </div>
        <div class="col-sm-10 px-1">
          <input type="text" id="lname" name="lastname" placeholder="Your last name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-2 px-1">
          <label for="province">Tỉnh TP</label>
        </div>
        <div class="col-sm-2 px-1">
          <select id="province-select" name="province" class="form-control">
          </select>
        </div>
        <div class="col-sm-2 px-2">
          <label for="district">Quận huyện</label>
        </div>
        <div class="col-sm-2 px-1">
          <select id="district-select" disabled name="district" class="form-control">
          </select>
        </div>
        <div class="col-sm-2 px-2">
          <label for="ward">Phường xã</label>
        </div>
        <div class="col-sm-2 px-1">
          <select id="ward-select" disabled name="ward" class="form-control">
          </select>
        </div>
      </div>
      <div class="row text-right">
        <div class="col-sm-12">
          <input type="button" value="Send" class="btn btn-info" id="send-button">
        </div>
      </div>
    </form>
  </div>
  <script>
    var gProvinceSelectElement = $("#province-select");    
    var gDistrictSelectElement = $("#district-select");
    var gWardSelectElement = $("#ward-select");
    // khi load trang gọi api lấy danh sách tỉnh thành phố
    $.ajax({
      url: "http://localhost:8080/devcamp-provinces",
      method: "GET",
      success: function(pObjRes) {
        console.log(pObjRes);
        loadDataToProvinceSelect(pObjRes);
      },
      error: function(pXhrObj) {
        console.log(pXhrObj);
      }
    });
    // đổ dữ liệu vào select tỉnh thành phố
    function loadDataToProvinceSelect(pProvinceList) {
      for (i = 0; i < pProvinceList.length; i++) {
        var bProvinceOption = $("<option/>");
        bProvinceOption.prop("value", pProvinceList[i].code);
        bProvinceOption.prop("text", pProvinceList[i].name);
        gProvinceSelectElement.append(bProvinceOption);
      };
    }
    // khi chọn một option tỉnh thành phố khác, xóa trắng và disable select quận huyện và select phường xã
    gProvinceSelectElement.on("change", function () {
      gDistrictSelectElement.html("").prop("disabled", true);
      gWardSelectElement.html("").prop("disabled", true);
      var vProvinceCode = $(this).val();
      console.log("Đã chọn province có code là: " + vProvinceCode);
      getDistrictsByProvinceCode(vProvinceCode);
    });
    // gọi api lấy danh sách quận huyện
    function getDistrictsByProvinceCode(pProvinceCode) {
      $.ajax({
        url: "http://localhost:8080/devcamp-districts?code=" + pProvinceCode,
        method: "GET",
        success: function(pObjRes) {
          console.log(pObjRes);
          loadDataToDistrictSelect(pObjRes);
        },
        error: function(pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }    
    // đổ dữ liệu vào select quận huyện
    function loadDataToDistrictSelect(pDistrictList) {
      if (pDistrictList.length > 0) {
        gDistrictSelectElement.prop("disabled", false);

        for (i = 0; i < pDistrictList.length; i++) {
          var bDistrictOption = $("<option/>");
          bDistrictOption.prop("value", pDistrictList[i].id);
          bDistrictOption.prop("text", pDistrictList[i].prefix + " " + pDistrictList[i].name);
          gDistrictSelectElement.append(bDistrictOption);
        };
      }
    }
    // khi chọn một option quận huyện khác, xóa trắng và disable select phường xã
    gDistrictSelectElement.on("change", function () {
      gWardSelectElement.html("").prop("disabled", true);
      var vDistrictId = $(this).val();
      console.log("Đã chọn district có id là: " + vDistrictId);
      getWardsByDistrictId(vDistrictId);
    });
    // gọi api lấy danh sách phường xã
    function getWardsByDistrictId(pDistrictId) {
      $.ajax({
        url: "http://localhost:8080/devcamp-wards?districtId=" + pDistrictId,
        method: "GET",
        success: function(pObjRes) {
          console.log(pObjRes);
          loadDataToWardSelect(pObjRes);
        },
        error: function(pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }    
    // đổ dữ liệu vào select phường xã
    function loadDataToWardSelect(pWardList) {
      if (pWardList.length > 0) {
        gWardSelectElement.prop("disabled", false);

        for (i = 0; i < pWardList.length; i++) {
          var bWardOption = $("<option/>");
          bWardOption.prop("value", pWardList[i].id);
          bWardOption.prop("text", pWardList[i].prefix + " " + pWardList[i].name);
          gWardSelectElement.append(bWardOption);
        };
      }
    }

  </script>
</body>

</html>